//+------------------------------------------------------------------+
//|                                                                  |
//|                                  Copyright © 2016, xClus1v3 Inc. |
//|                                      http://www.mqlconverter.com |
//+------------------------------------------------------------------+
#property copyright "Copyright © 2016, xClus1v3 Inc"
#property link      "http://www.mqlconverter.com"
#property version   "6.8"
#property strict

//+------------------------------------------------------------------+
//| EX5 defines                                                      |
//+------------------------------------------------------------------+
#define MODE_OPEN 0
#define MODE_LOW 1
#define MODE_HIGH 2
#define MODE_CLOSE 3
#define MODE_VOLUME 4 

#define MODE_TIME 5
#define MODE_BID 9

#define MODE_ASK 10

#define MODE_POINT 11

#define MODE_DIGITS 12

#define MODE_SPREAD 13

#define MODE_STOPLEVEL 14

#define MODE_LOTSIZE 15

#define MODE_TICKVALUE 16

#define MODE_TICKSIZE 17

#define MODE_SWAPLONG 18

#define MODE_SWAPSHORT 19

#define MODE_STARTING 20

#define MODE_EXPIRATION 21

#define MODE_TRADEALLOWED 22

#define MODE_MINLOT 23

#define MODE_LOTSTEP 24

#define MODE_MAXLOT 25

#define MODE_SWAPTYPE 26

#define MODE_PROFITCALCMODE 27

#define MODE_MARGINCALCMODE 28

#define MODE_MARGININIT 29

#define MODE_MARGINMAINTENANCE 30

#define MODE_MARGINHEDGED 31

#define MODE_MARGINREQUIRED 32

#define MODE_FREEZELEVEL 33

#define MODE_CLOSEBY_ALLOWED 34
//##########ORDER TYPES##########//
#define OP_BUY       0
#define OP_SELL      1
#define OP_BUYLIMIT  2
#define OP_SELLLIMIT 3
#define OP_BUYSTOP   4
#define OP_SELLSTOP  5
#define OP_BALANCE 6

//       Indicator MODES Definition
#define MODE_MAIN 0
#define MODE_SIGNAL 1
//Alligator
#define MODE_GATORJAW 1
#define MODE_GATORTEETH 2
#define MODE_GATORLIPS 3
//ADX Specials
#define MODE_PLUSDI 1
#define MODE_MINUSDI 2
//Multiple Indicator ENUMs
#define MODE_UPPER   1
#define MODE_LOWER   2
//iIchimoku 
#define MODE_TENKANSEN  1
#define MODE_KIJUNSEN   2
#define MODE_SENKOUSPANA 3
#define MODE_SENKOUSPANB 4
#define MODE_CHINKOUSPAN 5

#define CHART_BAR 0
#define CHART_CANDLE 1

#define SELECT_BY_POS 0
#define SELECT_BY_TICKET 1

#define MODE_TRADES 0
#define MODE_HISTORY 1

#define Point _Point
#define Digits _Digits

#define Ask Ask_()
#define Bid Bid_()
#define Bars Bars_()
#define OrdersTotal OrdersTotal_

#import "PZ_MA_Crossover_lib.ex5"
double Ask_(void);
double Bid_(void);
int Bars_(void);
double iATR(string symbol,int timeframe,int period,int shift);
double iClose(string symbol,int timeframe,int index=0);
double iHigh(string symbol,int timeframe,int index=0);
double iLow(string symbol,int timeframe,int index=0);
double iMA(string symbol,int timeframe,int period,int ma_shift,int ma_method,int applied_price,int shift);
bool IsTradeContextBusy(void);
datetime iTime(string symbol,int timeframe,int index=0);
double MarketInfo(string symbol,int type);
bool OrderClose(int ticket,double lots,double price,int slippage,color arrow_color=CLR_NONE);
double OrderClosePrice(void);
string OrderComment(void);
double OrderLots(void);
int OrderMagicNumber(void);
bool OrderModify(int ticket,double price,double stoploss,double takeprofit,datetime expiration=0,color arrow_color=CLR_NONE);
double OrderOpenPrice(void);
bool OrderSelect(int index,int select,int pool=MODE_TRADES);
int OrderSend(const string symbol,int cmd,double volume,double openprice,int slippage,double stoploss,double takeprofit,
              const string comment=NULL,int magic=0,datetime expiration=0,color arrow_clr=CLR_NONE);
double OrderStopLoss(void);
int OrdersTotal_(void);
string OrderSymbol(void);
double OrderTakeProfit(void);
int OrderTicket(void);
int OrderType(void);
int TimeHour(datetime date);
int TimeMinute(datetime date);
#import
#define __(N,V)                                                                                                                          \
  class _##N                                                                                                                                 \
  {                                                                                                                                          \
  public:                                                                                                                                    \
    V operator[](const int index) const                                                                                                      \
    {                                                                                                                                        \
      return(i##N(_Symbol, _Period, index));                                                                                                 \
    }                                                                                                                                        \
  };                                                                                                                                         \
                                                                                                                                             \
  _##N N;                                                                                                                                    \
  
__(Time,datetime)
